program laby;

{  UNITES  }
uses dos,crt,vbe2,vbe2ext,ugenere;

{  CONSTANTES  }
const
     RepertoireBGI = 'D:\TP\BGI';
     Fmenu         = 'laby.gab';
     {gestion clavier}
     a_gauche      = #75;
     a_droite      = #77;
     en_haut       = #72;
     en_bas        = #80;
     curseur       = [en_haut,en_bas,a_gauche,a_droite];
     espace        = #32; {vue en 2D}
     echap         = #27; {abandon}
     Entree        = #13; {validation}
     un            = #49; {poser la marque 1}
     deux          = #50; {poser la marque 2}
     trois         = #51; {poser la marque 3}
     quatre        = #52; {poser la marque 4}
     cinq          = #53; {poser la marque 5}
     six           = #54; {poser la marque 6}
     touche_marques= [un,deux,trois,quatre,cinq,six];
     {Gestion}
     NbMarquesMax  = 6;
     NbApercusMax  = 20;
     {Affichage}
     NbPlans       = 10;
     ciel          = 9; {LightBlue}
     mur1          = 8; {DarkGray}
     mur2          = 7; {LightGray}
     sol           = 2; {Green}
     coul_indic    = 14;{Yellow}
     coul_depart   = 14;{Yellow}
     coul_arrivee  = 4; {Red}
     Triangle_ciel: array[1..3] of Pointtype = ((X:0;Y:80),(X:639;Y:80),(X:320;Y:200));
     Triangle_murD: array[1..3] of Pointtype = ((X:639;Y:80),(X:639;Y:479),(X:320;Y:200));
     Triangle_murG: array[1..3] of Pointtype = ((X:0;Y:80),(X:0;Y:479),(X:320;Y:200));
     Triangle_sol : array[1..3] of Pointtype = ((X:0;Y:479),(X:639;Y:479),(X:320;Y:200));

{  TYPES  }
type
    Toption = record
              val,min,max:byte;
              end;
    TtabOptions = array [0..3] of Toption;
    Tmarque = record
              x,y,coul:word;
              end;
    Tdroite = record
              a:real;
              b:real;
              end;
    Tbornes = record
              abs_min:integer;
              abs_max:integer;
              end;
    Ttab_plans = array [0..NbPlans] of Tbornes;

{  VARIABLES  }
var
   quitter:boolean;
   NbMarques:byte;
   NbApercus:byte;
   apercus:integer;
   position:Tposition;
   marques:array[1..NbMarquesMax] of Tmarque;
   Page:byte;
   DroiteHG:Tdroite;
   DroiteBG:Tdroite;
   DroiteHD:Tdroite;
   DroiteBD:Tdroite;
   tab_plans:Ttab_plans;
   gagne:boolean;
   touche:char;
   dessiner:boolean;{ vrai lorsqu'il faut redessiner}

{ UTILITAIRES }

{****************************************************************************}
function Int2Str(Int:integer):string;
var s:string;
begin
  str(Int,s);
  Int2Str:=s;
end;
{****************************************************************************}
function min(a,b:integer):integer;
begin
  min:=a;
  if b<a then min:=b;
end;
{****************************************************************************}
procedure deplacement (diror:Tdiror;var dx,dy:integer);
begin
   dx:=0;
   dy:=0;
   case diror of
        H:dec(dy);
        D:inc(dx);
        B:inc(dy);
        G:dec(dx);
   end; {of case}
end;
{************************* passage en mode graphique ************************}
procedure mode_graphique;
begin
  initgraph(640,480,8,RepertoireBGI);
end;
{****************************************************************************}

{ MENU }

{****************************************************************************}
procedure Afficher_schema;
const
   x0=400;
   dx=150;
   y0=60;
   dy=120;
begin
  setcolor(White);
  rectangle(x0,y0,x0+dx,y0+dy);
  outtextxy(x0-10,y0+6,'1');
  outtextxy(x0+4,y0-10,'1');
  outtextxy(x0+20,y0+6,'Dpart');
  outtextxy(x0+dx-75,y0+dy-12,'Arrive');
  outtextxy(x0+dx div 2-textwidth('Longueur')div 2,y0-10,'Longueur');
  SetTextStyle(DefaultFont, VertDir, 1);
  outtextxy(x0-5,y0+dy div 2-textwidth('Largeur')div 2,'Largeur');
  SetTextStyle(DefaultFont, HorizDir, 1);
  setcolor(red);
  outtextxy(x0+dx div 2-5,y0+dy div 2-10,'');
  outtextxy(x0+dx div 2-5,y0+dy div 2,'N');
  setfillcolor(yellow);
  bar(x0+1,y0+1,x0+16,y0+16);
  setfillcolor(red);
  bar(x0+dx-16,y0+dy-16,x0+dx-1,y0+dy-1);
end;
{****************************************************************************}
procedure Afficher_aide;
const
     x0=5;
     y0=190;
begin
  setcolor(darkgray);
  outtextxy(x0,y0,'Pour ce menu, utilisez les flches haut et bas pour colorer l''option ');
  outtextxy(x0,y0+10,'changer en jaune, puis les flches gauche et droite pour modifier la valeur.');
  outtextxy(x0,y0+25,'Le but est de traverser le labyrinthe. Un seul chemin mne  l''arrive. Pour');
  outtextxy(x0,y0+35,'vous y aider, vous avez  votre disposition une boussole en bas de l''cran qui');
  outtextxy(x0,y0+45,'vous indique le Nord ainsi qu''un indicateur de position (en haut  gauche):');
  outtextxy(x0,y0+55,'- abs pour l''abscisse: numro de case sur la longueur (=1 sur le dpart)');
  outtextxy(x0,y0+65,'- ord pour l''ordonne: numro de case sur la largeur  (=1 sur le dpart)');
  outtextxy(x0,y0+80,'Vous pouvez utiliser jusqu'' 6 marques de couleurs diffrentes pour vous');
  outtextxy(x0,y0+90,'reprer. Chaque marque appose sa couleur sur la case o se trouve le joueur.');
  outtextxy(x0,y0+100,'Pour poser ou supprimer une marque, utilisez les touches 1  Nb Marques (max=6)');
  outtextxy(x0,y0+110,'du clavier numrique.');
  outtextxy(x0,y0+125,'Le dplacement se fait avec les flches "Haut"(avancer), "bas"(reculer),');
  outtextxy(x0,y0+135,'"Gauche" et "Droite" (pour pivoter). Vous pouvez aussi consulter un nombre');
  outtextxy(x0,y0+145,'limit de fois (=Nb aperus 2D) le plan du labyrinthe en 2D en utilisant la');
  outtextxy(x0,y0+155,'barre d''espace. Sur ce plan apparat:');
  outtextxy(x0,y0+165,'- votre position et votre direction indiques par la flche jaune,');
  outtextxy(x0,y0+175,'- le dpart (carr jaune) et l''arrive (carr rouge),');
  outtextxy(x0,y0+185,'- les marques dposes (carrs de la mme couleur que les marques).');
  outtextxy(x0,y0+195,'Le nombre de "vues 2D" encore disponibles est indiqu en haut  droite de');
  outtextxy(x0,y0+205,'l''cran de jeu.');
  outtextxy(x0,y0+220,'Le jeu garde en mmoire la dernire configuration du menu dans le fichier');
  outtextxy(x0,y0+230,'"serpent.gab". Pour fonctionner, celui-ci doit tre pla dans le mme');
  outtextxy(x0,y0+240,'rpertoire que cet xcutable et son nom ne doit pas tre modifi.');
  setcolor(yellow);
  outtextxy((GetMaxX-TextWidth('Bon jeu!'))div 2,y0+255,'Bon jeu!');
end;
{****************************************************************************}
procedure Afficher_pub;
begin
  setcolor(55);{bleu clair}
  outtextxy(132,465,'Tlcharg sur http://stephane.gabourin.free.fr');
end;
{****************************************************************************}
procedure Afficher_options(Tab:TtabOptions;l_active:integer);
const
     x0=50;
     y0=90;
     Labels : array [0..3] of string[15]
            = ('Longueur', 'Largeur', 'Nb marques', 'Nb aperus 2D');
var
   i:byte;
begin
  setfillcolor(black);
  bar(x0+120,y0,x0+135,y0+42);
  for i:=0 to 3 do begin
    if i=l_active then setcolor(Yellow) else setcolor(White);
    outtextxy(x0,y0+12*i,Labels[i]);
    outintxy(x0+120,y0+12*i,Tab[i].val);
    outtextxy(x0+150,y0+12*i,'de '+Int2Str(Tab[i].min)+'  '+Int2Str(Tab[i].max));
  end;
  setcolor(LightGray);
  outtextxy(x0,y0+48,'Appuyez sur Echap pour quitter le menu');
end;
{****************************************************************************}
procedure DefinirParametres(var Tab:TtabOptions);
var
   DirInfo:SearchRec;
   F:Text;
begin
  FindFirst(Fmenu,AnyFile,DirInfo);
  if DosError=18 then {pas de fichier=>valeurs par dfaut}
  begin
    Tab[0].val:=10;{longueur}
    Tab[1].val:=8; {largeur}
    Tab[2].val:=3; {Nb marques}
    Tab[3].val:=3; {Nb apercus 2D}
  end else
  begin
    Assign(F,Fmenu);
    Reset(F);
    Read(F,Tab[0].val);
    Read(F,Tab[1].val);
    Read(F,Tab[2].val);
    Read(F,Tab[3].val);
    Close(F);
  end;
  Tab[0].min:=3;
  Tab[0].max:=longueur_max;
  Tab[1].min:=3;
  Tab[1].max:=largeur_max;
  Tab[2].min:=0;
  Tab[2].max:=NbMarquesMax;
  Tab[3].min:=0;
  Tab[3].max:=NbApercusMax;
end;
{****************************************************************************}
procedure SauverParametres(Tab:TtabOptions);
var
   F:Text;
   DirInfo: SearchRec;
   i:byte;
begin
   FindFirst(Fmenu, Anyfile, DirInfo);
   Assign(F,Fmenu);
   Rewrite(F);
   for i:=0 to 3 do Writeln(F,Tab[i].val);
   Close(F);
end;
{****************************************************************************}
procedure menu(var quitter:boolean);
const
     tabcoul:TColorsArray=(126,124,122,120);
var
   touche:char;
   Tab:TtabOptions;
   l_cour:integer;
begin
  Cleardevice;
  setcolor(white);
  rectangle(0,0,GetMaxX-1,GetMaxY-1);
  SetTextStyle(DefaultFont, HorizDir, 3);
  outcooltextxy((GetMaxX-TextWidth('Labyrinthe 3D'))div 2,15,'Labyrinthe 3D',tabcoul);
  SetTextStyle(DefaultFont, HorizDir, 1);
  Afficher_schema;
  Afficher_aide;
  Afficher_pub;
  DefinirParametres(Tab);
  {gestion interactive du menu}
  l_cour:=0;
  Afficher_options(Tab,l_cour);
  repeat
    touche:=readkey;
    case touche of
    en_haut :l_cour:=(l_cour+3)mod 4;
    en_bas  :l_cour:=(l_cour+1)mod 4;
    a_gauche:with Tab[l_cour] do
               if (val>min)
                 then dec(val)
                 else val:=max;
    a_droite:with Tab[l_cour] do
               if (val<max)
                 then inc(val)
                 else val:=min;
    end;
    Afficher_options(Tab,l_cour);
  until (touche=Entree) or (touche=Echap);
  if touche=Entree then
  begin
    longueur :=Tab[0].val;
    largeur  :=Tab[1].val;
    NbMarques:=Tab[2].val;
    NbApercus:=Tab[3].val;
  end else
  begin
    quitter:=true;
    SauverParametres(Tab);
  end;
end;
{****************************************************************************}

{ INITIALISATIONS }

{****************************************************************************}
procedure init_droites;
begin
   DroiteHG.a:=120/319;
   DroiteHG.b:=200-320*DroiteHG.a;
   DroiteBG.a:=-279/319;
   DroiteBG.b:=200-320*DroiteBG.a;
   DroiteHD.a:=-120/319;
   DroiteHD.b:=200-320*DroiteHD.a;
   DroiteBD.a:=279/319;
   DroiteBD.b:=200-320*DroiteBD.a;
end;
{****************************************************************************}
{Attention l c'est chaud bouillant: calcul des largeurs}
procedure init_plans;
const
     a=80;{pourcentage de la largeur d'un couloir par rapport  la largeur incluant les murs}
     pxl_depart=40;{marge de 40  gauche et  droite}
     largeur_pxl=260;{largeur d'affichage d'un mur (G ou D) en pixels}
var
   i,c1,c2:byte; {c1 et c2: nb de fois que a et b sont  prendre en compte
                  pour le calcul de l'angle de vision d'un mur/couloir}
   alpha0,alpha,angle_tot:real;{angles de vision des murs et couloirs}
   b:word;{b:pourcentage de l'paisseur d'un mur par rapport au couloir}
   larg_eq:word;{largeur calcule pour un mur ou un couloir}
begin
  b:=100-a;{a+b=100%}
  alpha0:=arctan(a/(a+b)); {faire un dessin pour re-comprendre les calculs...}
  angle_tot:=pi/2-alpha0;
  tab_plans[0].abs_min:=0;
  tab_plans[0].abs_max:=pxl_depart;
  c1:=1;
  c2:=0;
  for i:=1 to NbPlans do
  begin
   alpha:=arctan((c1*a+(c2+2)*b)/(a+b))-arctan((c1*a+c2*b)/(a+b));
   larg_eq:=round(alpha*largeur_pxl/angle_tot);
   tab_plans[i].abs_min:=tab_plans[i-1].abs_max+larg_eq;
   inc(c2,2);
   alpha:=arctan(((c1+2)*a+c2*b)/(a+b))-arctan((c1*a+c2*b)/(a+b));
   larg_eq:=round(alpha*largeur_pxl/angle_tot);
   tab_plans[i].abs_max:=tab_plans[i].abs_min+larg_eq;
   inc(c1,2);
  end;
end;
{****************************************************************************}
procedure init_position (var pos:Tposition);
begin
   pos.abs:=1;
   pos.ord:=1;
   pos.diror:=D;
   if mat[1,1][D] then pos.diror:=B;
end;
{****************************************************************************}
procedure init_marques;
var
   i:byte;
begin
  for i:=1 to NbMarques do
  begin
    marques[i].x:=0;
    marques[i].y:=0;
    marques[i].coul:=2*i-1;
  end;
end;
{****************************************************************************}
procedure InitPagesLogiques;
begin
   Page:=0;
   SetVisualPage(0);
   SetActivePage(1);
end;
{****************************************************************************}
procedure initialisations(var pos:Tposition);
begin
  touche:=#0;
  gagne:=false;
  InitPagesLogiques; {doit tre fait aprs mode_graphique}
  init_droites;
  init_plans;
  init_marques; {doit tre fait aprs le menu}
  generer_laby;
  init_position(pos);{doit tre fait aprs la gnration du laby}
end;
{****************************************************************************}

{ PAGES LOGIQUES }

{****************************************************************************}
procedure InversePagesLogiques;
begin
   SetActivePage(Page);
   Page:=(Page+1)mod 2;
   SetVisualPage(Page);
end;
{****************************************************************************}
procedure StopPagesLogiques;
begin
   SetActivePage(Page);{Active et visual deviennent les mmes}
end;
{****************************************************************************}

{ DONNER POSITION }

{****************************************************************************}
procedure afficher_laby (dim_case:integer);
var
   long,larg:integer;
   diror:Tdiror;
begin
   cleardevice;
   setlinestyle(0,0,3);
   setcolor(yellow);
   for larg:=1 to largeur do
       for long:=1 to longueur do
           for diror :=H to G do
               if mat[long,larg][diror] then
                  case diror of
                       H : line (dim_case*(long-1),dim_case*(larg-1),
                                 dim_case*long    ,dim_case*(larg-1) );
                       D : line (dim_case*long    ,dim_case*(larg-1),
                                 dim_case*long    ,dim_case*larg     );
                       B : line (dim_case*(long-1),dim_case*larg    ,
                                 dim_case*long    ,dim_case*larg     );
                       G : line (dim_case*(long-1),dim_case*(larg-1),
                                 dim_case*(long-1),dim_case*larg     );
                  end;
   setlinestyle(0,0,1);
   {Dpart et arrive}
   setfillcolor(yellow);
   bar(2, 2, dim_case-2, dim_case-2);
   setfillcolor(red);
   bar(dim_case*(longueur-1)+2 , dim_case*(largeur-1)+2,
       dim_case*longueur-2     , dim_case*largeur-2 );
end;
{****************************************************************************}
procedure donner_position (pos:Tposition);
var
   i,dim_case:integer;
begin
   dim_case := min (479 div largeur,639 div longueur)-1;
   inc(apercus);
   afficher_laby (dim_case);
{Affichage des marques}
   for i:=1 to NbMarques do
   begin
     SetFillColor(marques[i].coul);
     if (marques[i].x>0) then
       bar(dim_case*(marques[i].x-1)+2 , dim_case*(marques[i].y-1)+2,
           dim_case*marques[i].x-2     , dim_case*marques[i].y-2     );
   end;
{Indication du sens et de la position}
   case pos.diror of
        H:outtextxy(dim_case*(pos.abs-1)+dim_case div 2 -3,
                    dim_case*(pos.ord-1)+dim_case div 2 -3, '');
        D:outtextxy(dim_case*(pos.abs-1)+dim_case div 2 -3,
                    dim_case*(pos.ord-1)+dim_case div 2 -3, '');
        B:outtextxy(dim_case*(pos.abs-1)+dim_case div 2 -3,
                    dim_case*(pos.ord-1)+dim_case div 2 -3, '');
        G:outtextxy(dim_case*(pos.abs-1)+dim_case div 2 -3,
                    dim_case*(pos.ord-1)+dim_case div 2 -3, '');
   end;
   InversePagesLogiques;
   readkey;
end;
{****************************************************************************}

{ MODIFIER POSITION }

{****************************************************************************}
function predecesseur (diror:Tdiror):Tdiror;
begin
   if diror=H then predecesseur:=G
              else predecesseur:=pred(diror);
end;
{****************************************************************************}
function successeur (diror:Tdiror):Tdiror;
begin
   if diror=G then successeur:=H
              else successeur:=succ(diror);
end;
{****************************************************************************}
procedure modifier_position (touche:char;var pos:Tposition;
                             var pos_modifiee,gagne:boolean);
var
   dx,dy:integer;
begin
  pos_modifiee:=true;
  case touche of
    a_gauche  :
      pos.diror:=predecesseur(pos.diror);
    a_droite  :
      pos.diror:=successeur  (pos.diror);
    en_haut   : {en avant}
      begin
      pos_modifiee:=not mat[pos.abs,pos.ord][pos.diror];
      if pos_modifiee
      then begin
           deplacement (pos.diror,dx,dy);
           inc(pos.abs,dx);
           inc(pos.ord,dy);
           end;
      end;
    en_bas    : {en arrire}
      begin
      pos_modifiee:=not mat[pos.abs,pos.ord][successeur(successeur(pos.diror))];
      if pos_modifiee
      then begin
           deplacement (successeur(successeur(pos.diror)),dx,dy);
           inc(pos.abs,dx);
           inc(pos.ord,dy);
           end;
      end;
  end; {of case}
  gagne:=(pos.abs=longueur) and (pos.ord=largeur);
end;
{****************************************************************************}

{ DESSINER DECOR }

{****************************************************************************}
procedure dessine_ecran_de_base;
begin
  SetFillColor(mur2);
  FillPoly(3, Triangle_murD);
  FillPoly(3, Triangle_murG);
  SetFillColor(sol);
  FillPoly(3, Triangle_sol);
  SetColor(lightblue);
  SetFillColor(ciel);
  FillPoly(3, Triangle_ciel);
  setcolor(18);
  line(0,80,320,200);
  line(639,80,320,200);
  line(0,479,320,200);
  line(639,479,320,200);
  bar(0,0,639,79);
end;
{****************************************************************************}
function y (x:integer;droite:Tdroite):integer;
begin
   with droite do y := round (a*x + b);
end;
{****************************************************************************}
procedure DessineQuadri(x1,y1,x2,y2,x3,y3,x4,y4,coul:word);{dessine une case au sol}
var
   quadri: array [1..4] of Pointtype;
   i:byte;
begin
  SetFillColor(coul);
  quadri[1].X:=x1;
  quadri[1].Y:=y1;
  quadri[2].X:=x2;
  quadri[2].Y:=y2;
  quadri[3].X:=x3;
  quadri[3].Y:=y3;
  quadri[4].X:=x4;
  quadri[4].Y:=y4;
  FillPoly(4, quadri);
end;
{****************************************************************************}
procedure dessiner_le_plan (pos:Tposition;plan:integer);
var
   i,dx,dy:integer; {pour trouver la bonne profondeur de case dans la matrice}
   x_minG,x_maxG,x_minD,x_maxD:integer;{bornes de chaque renfoncement eventuel}
begin
   with pos do
   begin
      deplacement (diror,dx,dy); {on va voir une case plus loin}
      x_minG:=tab_plans[plan].abs_min;   {rcup des x et y d'affichage}
      x_maxG:=tab_plans[plan].abs_max-1; {pour le plan concern}
      x_minD:=640-x_maxG;                {les dimensions sont symtriques}
      x_maxD:=640-x_minG;                {entre la droite et la gauche}
      if (not mat[abs+plan*dx,ord+plan*dy][predecesseur(diror)]) then
      begin {cote gauche}
         SetFillColor(ciel);
         bar( x_minG , y(x_minG,DroiteHG) , x_maxG , y(x_maxG,DroiteHG) );
         SetFillColor(sol);
         bar( x_minG , y(x_maxG,DroiteBG) , x_maxG , y(x_minG,DroiteBG) );
         SetFillColor(mur1);
         bar( x_minG , y(x_maxG,DroiteHG) , x_maxG , y(x_maxG,DroiteBG) );
      end;
      if (not mat[abs+plan*dx,ord+plan*dy][successeur(diror)]) then
      begin {cote droit}
         SetFillColor(ciel);
         bar( x_minD , y(x_maxD,DroiteHD) , x_maxD , y(x_minD,DroiteHD) );
         SetFillColor(sol);
         bar( x_minD , y(x_minD,DroiteBD) , x_maxD , y(x_maxD,DroiteBD) );
         SetFillColor(mur1);
         bar( x_minD , y(x_minD,DroiteHD) , x_maxD , y(x_minD,DroiteBD) );
      end;
      {affichage du dpart}
      if (abs+plan*dx=1) and (ord+plan*dy=1) then
        DessineQuadri(x_maxG,y(x_maxG,DroiteBG),x_minD,y(x_minD,DroiteBD),
                      x_maxD,y(x_maxD,DroiteBD),x_minG,y(x_minG,DroiteBG),
                      coul_depart);
      {affichage de l'arrive}
      if (abs+plan*dx=longueur) and (ord+plan*dy=largeur) then
        DessineQuadri(x_maxG,y(x_maxG,DroiteBG),x_minD,y(x_minD,DroiteBD),
                      x_maxD,y(x_maxD,DroiteBD),x_minG,y(x_minG,DroiteBG),
                      coul_arrivee);
      {gestion des marques}
      for i:=1 to NbMarques do
        if (marques[i].x=abs+plan*dx) and (marques[i].y=ord+plan*dy) then
        begin
          DessineQuadri(x_maxG,y(x_maxG,DroiteBG),x_minD,y(x_minD,DroiteBD),
                        x_maxD,y(x_maxD,DroiteBD),x_minG,y(x_minG,DroiteBG),
                        marques[i].coul);
        end;
   end;
end;
{****************************************************************************}
procedure dessiner_le_mur_du_fond (plan:integer);
var
   x_min,x_max:integer;
begin
   x_min:=tab_plans[plan].abs_max-1;
   x_max:=640-x_min;
   SetFillColor(mur1);
   bar( x_min , y(x_min,DroiteHG) , x_max , y(x_max,DroiteBD) );
end;
{****************************************************************************}
procedure affiche_les_indicateurs(pos:Tposition);
begin
   {coordonnes abs et ord}
   setcolor(coul_indic);
   SetTextStyle(DefaultFont,HorizDir,1);
   outtextxy(1,15,'abs=');
   outtextxy(1,35,'ord=');
   with pos do
   begin
      SetTextStyle(DefaultFont,HorizDir,2);
      outtextxy(40,10,Int2Str(abs));
      outtextxy(40,30,Int2Str(ord));
      {boussole indiquant le nord}
      SetTextStyle(DefaultFont,HorizDir,3);
      outtextxy(315,430,'N');
      case diror of
           H:outtextxy(315,405,'');
           D:outtextxy(285,430,'');
           B:outtextxy(315,455,'');
           G:outtextxy(345,430,'');
      end;
   end;
   {Nb d'aperus du plan 2D encore disponibles}
   SetTextStyle(DefaultFont,HorizDir,1);
   outtextxy(520,15,'Vues 2D:');
   SetTextStyle(DefaultFont,HorizDir,2);
   outintxy(600,10,Nbapercus-apercus);
   SetTextStyle(DefaultFont,HorizDir,0);
end;
{****************************************************************************}
procedure dessiner_decor (pos:Tposition);
var
   dx,dy,avancee:integer;
begin
   dessine_ecran_de_base;
   avancee:=0;
   dessiner_le_plan (pos,avancee);
   deplacement (pos.diror,dx,dy);
   while (not mat [pos.abs+avancee*dx , pos.ord+avancee*dy] [pos.diror]) and
         (avancee < NbPlans) do
   begin
      inc(avancee);
      dessiner_le_plan (pos,avancee);
   end;
   dessiner_le_mur_du_fond (avancee);
   affiche_les_indicateurs(pos);
end;
{****************************************************************************}

{ POSER MARQUE }

{****************************************************************************}
procedure poser_marque(pos:Tposition;num:word);
begin
  if (marques[num].x=pos.abs) and (marques[num].y=pos.ord)then
  begin
    marques[num].x:=0;
    marques[num].y:=0;
  end else
  begin
    marques[num].x:=pos.abs;
    marques[num].y:=pos.ord;
  end;
end;
{****************************************************************************}

{ SORTIE }

{****************************************************************************}
procedure sortie (gagne:boolean);
begin
   StopPagesLogiques;
   setcolor(yellow);
   SetTextStyle(DefaultFont,HorizDir,2);
   if gagne
   then outtextxy((GetMaxX-TextWidth('GAGNE'))div 2,30,'GAGNE')
   else outtextxy((GetMaxX-TextWidth('c''est fini'))div 2,30,'c''est fini');{appui su Echap}
   readln;
end;
{****************************************************************************}


{}
{                                                                          }
{                           PROGRAMME PRINCIPAL                            }
{                                                                          }
{}

var i:integer;
BEGIN
  mode_graphique;
  menu(quitter);
  while not quitter do
  begin
    initialisations(position);
    dessiner_decor (position);
    InversePagesLogiques;
    repeat
      if keypressed
      then begin
           touche:=readkey;
           dessiner:=true;
           if touche in curseur
           then modifier_position (touche,position,dessiner,gagne)
           else if touche=espace
                then begin
                     if apercus<=NbApercus then donner_position (position);
                     end
                else if touche in touche_marques
                     then poser_marque(position,ord(touche)-48)
                     else dessiner:=false;
           if dessiner then
              begin
              dessiner_decor (position);
              InversePagesLogiques;
              end;
           end;
    until (touche = echap) or (gagne);
    sortie(gagne);
    menu(quitter);
  end;
  closegraph;
END.
